#!/usr/bin/perl -w
################################################################################
# domain and web setup (c) 2001 by Manuel Capellari <bad.sector@fd0h1440.com>  #
# dies ist ein script zum einrichten von virtuellen webservern und domains,    #
# das script ist auf effizienz ausgerichtet und beschrnkt sich auf das wesent #
# liche, es unterliegt der GNU Public License                                  #
################################################################################

use strict;
use Term::ReadKey;   #Term::ReadKey Modul kann verwendet werden um das terminal echo fuer passwoerter zu deaktivieren, per default ist dies aktiviert
use POSIX qw(strftime);

################################################################################
# zu editierende Variablen
################################################################################
my $timer_start=time; # zeitmessung einleiten
my $highscore="./topten.log";
my $debug="false";		# debugging messages, default ist "false"
my $ver="version 0.2";		# versions nummer ...
my $maxlength="20";		# maximale laenge eines benutzernamens
my $rfcmaxlen="63";		# maximale laenge einer TLD laut rfc 1034 und 1035
my $rfcminlen="3";		# minimale laenge einer TLD laut rfc 1034 und 1035
my $tldlen="67";		# maximale laenge einer TLD laut internic
my $http_conf="./etc/httpd/conf/httpd.conf";	# pfad zu httpd.conf
my $serverip="123.56.78.90";	# ip adresse des webservers
my $sub="";			# noch nicht implementiert
my $webdir="./home/wwwusers";	# default home fuer webusers
my $htdir="htdocs";		# default wwwroot
my $serverlog="./var/log/httpd/http_access.log";	# pfad zum serverlog
my $httprestart="/etc/init.d/httpd restart";	# apache restart kommando
my $localhostnames="/etc/mail/local-host-names";# pfad zu local-host-names
my $virtusertab="./etc/mail/virtusertable";	# pfad zu virtusertable
my $now=strftime "%a %b %e %H:%M:%S %Y", localtime;	# timestamp-generator
my $usersuffix="webmaster";	# default webuser
my $salt="\S1";			# SALT value, infos dazu unter 'man crypt'
### my $defuser1="office";	# zusaetzliches usermapping in der virtusertable
### my $defuser2="info";	# zusaetzliches usermapping in der virtusertable

################################################################################
# ab hier gibts nix mehr was man editieren sollte, ohne zu wissen was man tut
################################################################################
system ("clear");
print "\n".("#"x80)."\n";
print "domain and web setup $ver (c) 2001 by manuel capellari MC812866-NICAT\n";
print "it generates virtualhost containers in httpd.conf, adds the domain to\n";
print "the local-host-names file and finaly adds the useraccount \<CTRL\>+\<C\> to cancel";
print "\n".("#"x80)."\n\n";

user_add();

################################################################################
# multiple choice dialog noch nicht aktiv
################################################################################
#print "\"add\" or \"del\":\n";
#chomp (my $action=<STDIN>);
#
#if ($action eq "add") 
#		{
#		user_add();	#sub routine zum hinzfuegen von usern
#		}
#		else
#		{
#		user_del();
#		}
################################################################################

################################################################################
# domain einrichten und user erstellen
################################################################################
sub user_add {

	print "DOMAIN NAME:\t\t"; 			#domain abfragen
	    chomp (my $domain=<STDIN>);
	    if ($sub eq "")
		{
		$sub="www";				#wenn $sub "" dann = "www"
		}
	    if ($domain eq "")
		{
		die "no Domain name given\!, script terminated\!\n";
		}


################################################################################
# ueberpruefung ob die laenge des domain namens gemaess RFC 1034 vergeben wurde
################################################################################
	    (my $rawdom, my $domsuffix) = split (/\./,$domain);
	    if ($domsuffix eq "")
		{
		die "no Domain Suffix given\!, check RFC 1034 and 1035\!\n";
	    	}
	    if (length $rawdom > $rfcmaxlen)
		{
		die "supplied Domain is to invalid (may be to long), check RFC 1034 and 1035\!\n";
	    	}
	    if (length $domain > $tldlen)
		{
		die "supplied Domain is to invalid (may be to long), check RFC 1034 and 1035\!\n";
	    	}
	    if (length $rawdom < $rfcminlen)
		{
		die "supplied Domain is to invalid (may be to short), check RFC 1034 and 1035\!\n";
	    	}
	    
	    
	print "ALIAS DOMAIN:\t\t"; 			#alias domain einrichten
	chomp (my $serveralias=<STDIN>);
	    if ($serveralias eq "")	
		{
		$serveralias="# not set";
		}

	print "USERNAME ($domain\_$usersuffix):"; 	#benutzernamen abfragen
	chomp (my $username=<STDIN>);	
	    if ($username eq "")
		{
		$username="$domain\_$usersuffix";
		}
		my $len = length($username);
		print "Username is $len bytes long\n"; #laenge des benutzernamen feststellen

	    if ($len > $maxlength)
		{
		die "supplied Username is to long\n\!\nonly $maxlength bytes allowed\!\nUser Creation terminated\!\n";
		}

	print "COMMENT ($usersuffix\@$domain):";  	#kommentar abfragen
	chomp (my $comment=<STDIN>);	
	    if ($comment eq "")
		{
		$comment="$usersuffix\@$domain"		#defaultkommentar ist $usersuffix@$domain
		}

	print "GROUPNAME ($domain):";  			#gruppennamen abfragen
	chomp (my $groupname=<STDIN>);  
	    if ($groupname eq "")
		{
		$groupname=$domain			#defaultgruppe ist $domain
		}

	print "PASSWORD:\t\t";   			#passwort abfragen
	ReadMode('normal');				#terminal auf 'noecho' fuer die eingabe stellen
	chomp (my $password=ReadLine(0));
	my $encrypted=crypt ($password, $salt); 	#hier wird das passwort verschlsselt wobei $salt die SALT value ist, welche zur verschlsselung verwendet werden soll
	ReadMode('normal');				#terminal auf 'normalen' eingabe-modus umstellen
				
################################################################################
# systemaufruf zum hinzufuegen des users
################################################################################
		system ("/usr/sbin/groupadd $groupname");
		print "\nADDED GROUP \"$groupname\"\t\t\t\t\t\t[OK]\n";

	    if ($password eq "")
		{
		system ("/usr/sbin/useradd $username -g $groupname -d $webdir/$domain -s /bin/bash -c $comment");
		print "ADDED USER \"$username\" but not activated\t\t[OK]\n";
		} else { 
		system ("/usr/sbin/useradd $username -g $groupname -d $webdir/$domain -s /bin/bash -c $comment -p $encrypted");
		print "ADDED USER \"$username\"\t\t\t\t[OK]\n";
		}
		
################################################################################
# eintrag in die localhostnames
################################################################################
		open DATA, ">> $localhostnames" || die "could not open $localhostnames $!\n";
		print DATA "$domain\n";
		close DATA || die "could not close $localhostnames $!\n";
		print "ADDED \"$domain\" to $localhostnames\t\t\t\t[OK]\n";

################################################################################
# eintrag des webmaster accounts in virtusertable
################################################################################
		open DATA, ">> $virtusertab" || die "could not open $virtusertab $!\n";
		print DATA "$usersuffix\@$domain\t$username\n";
### disabled	print DATA "$defuser1\@$domain\t$domain\_$defuser1\n";
### disabled	print DATA "$defuser2\@$domain\t$domain\_$defuser2\n";
		close DATA || die "could not close $virtusertab $!\n";
		print "ADDED user mapping to $virtusertab\t\t\t\t[OK]\n";

################################################################################
# web einrichten
################################################################################
		open DATA, ">> $http_conf" || die "could not open $http_conf $!\n";               		# $http_conf wird fuer die ausgabe geoeffnet
		print DATA "\n\n### $sub.$domain\n";
		print DATA "### automatically generated on $now\n";
		print DATA ("#"x40)."\n";
		print DATA "<VirtualHost $serverip>\n";
		print DATA "ServerName $sub.$domain\n";
		print DATA "ServerAlias $serveralias\n";
		print DATA "DocumentRoot $webdir/$domain/$htdir/\n";
		print DATA "\tErrorLog $webdir/$domain/log/error_log\n";
		print DATA "\tTransferLog $webdir/$domain/log/access_log\n";
		print DATA "\tCustomLog $serverlog common\n";
		print DATA "ServerAdmin $usersuffix\@$domain\n";
		print DATA "ScriptAlias /cgi-bin/ $webdir/$domain/$htdir/cgi-bin/\n";
		print DATA "</VirtualHost>\n";
		close DATA || die "could not close $http_conf $!\n";
		system ("chmod 0755 $webdir/$domain/ -R");
		mkdir ("/$webdir/$domain/$htdir/cgi-bin",0777);
###		chown $username, $groupname, "$webdir/$domain/$htdir/cgi-bin";
		print "ADDED WEB \"$sub.$domain\" to $http_conf\t\t\t\t[OK]\n";

################################################################################
# zeitmessung, es wird gestoppt wie lange das einrichten des webs gedauert hat
################################################################################
my $timer_stop=time - $timer_start;	
	    if ($timer_stop < "26")
		{
		print "\n it took $timer_stop seconds to create \"$domain\" YEAH!\n";
		} else {
		print "\n it took $timer_stop seconds to create \"$domain\"\n";
		}
open DATA, ">> $highscore" || die "could not open $highscore $!\n";
print DATA "$domain \t\t\t$timer_stop\n";
close DATA || die "could not close $highscore $!\n";

################################################################################
# debugging info
################################################################################
	    if ($debug eq "true")
		{
	    print "DEBUGGING INFORMATION\n======================\n\$timer_start=$timer_start\n\$highscore=$highscore\n
		    \$http_conf=$http_conf\n\$serverip=$serverip\n\$sub=$sub\n\$webdir=$webdir\n\$htdir=$htdir\n
		    \$serverlog=serverlog\n\$localhostnames=localhostnames\n
		    \$ver=ver\n\$now=now\n\$domain=$domain\n\$username=$username\n\$serveralias=$serveralias\n
		    \$password=$password\n\$groupname=$groupname\n\$comment=$comment\n\$encrypted=$encrypted\n
		    \$timer_stop=$timer_stop\n\$debug=$debug\n\$usersuffix=$usersuffix";
		} else {
	    print "DEBUGGING IS DISABLED\n";
		}

################################################################################
# bestaetigung der domain
################################################################################
open DATA, ">> $domain.log" || die "could not open $domain.log $!\n";
print DATA "+--------------------------------------------------------------+\n";
print DATA "USER:\t\t\t\"$username\"\n";
print DATA "GROUP:\t\t\t\"$groupname\"\n";
print DATA "DOMAIN:\t\t\t\"$sub.$domain\"\n";
print DATA "ALIAS DOMAINs:\t\t\"$serveralias\"\n";
print DATA "ENCRYPTED PASSWORD:\t\"$encrypted\"\n";
print DATA "SERVERADMIN\t\t\"$usersuffix\@$domain\"\n";
print DATA "creation of this account took $timer_stop seconds\n";
print DATA "+--------------------------------------------------------------+\n";
close DATA || die "could not close $domain.log $!\n";

################################################################################
# apache restart
################################################################################
print "all work done, no trying to restart the httpd\n";
system ("$httprestart");
}

###############################################################################
# user loeschen
###############################################################################
# noch nicht aktiv
#sub user_del {
#	print "USERNAME:"; 	#benutzernamen abfragen
#	chomp (my $username=<STDIN>);	
#	system ("/usr/sbin/userdel -r $username") || die "could not delete $username $!";
#		print "\ndeleted $username\n";
#}
